can cause broken symlinks in /usr/share/doc

Bug #194574 reported by StefanPotyra on 2008-02-23
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
cdbs (Ubuntu)
Low
Martin Pitt

Bug Description

Binary package hint: cdbs

Hi,

cdbs should only place symlinks to a depending package in /usr/share/doc in case there the same (for ubuntu: source)-version is specified.

consider the following
source pacakge pfoo builds A and B
A depends on B

-> symlinks get created for /usr/share/doc/A/somefile -> ../B/somefile

pfoo is a new version.
B gets upgraded on a users system, A doesn't.
The new B doesn't contain /usr/share/doc/B/somefile any longer.

OTOH a >= dependency would equally fail:
B stays the same on the users system, A gets updated
the new B can contain a new doc entry someotherfile.
hence the new A contains a symlink to ../B/someotherfile
the old B on the users system doesn't containt that file.

This is an ubuntu only bug.

Cheers,
     Stefan.

Martin Pitt (pitti) on 2008-03-10
Changed in cdbs:
assignee: nobody → pitti
status: New → In Progress
Martin Pitt (pitti) wrote :

(I fixed the description to correct the directions)

Indeed this can happen. We don't support partial upgrades, so it's not such a big deal (thus the bug priority), but it's a pathological case. Question is whether we want to sacrifice a lot of disk space just to support partial upgrades without losing some files, and I don't even think that this happens often. Did you actually see this case in practice?

description: updated
Changed in cdbs:
importance: Undecided → Low
status: In Progress → Confirmed

Hi,

Am Dienstag, 11. März 2008 10:06 schrieb Martin Pitt:
> (I fixed the description to correct the directions)

thanks.

>
> Indeed this can happen. We don't support partial upgrades, so it's not
> such a big deal (thus the bug priority), but it's a pathological case.
> Question is whether we want to sacrifice a lot of disk space just to
> support partial upgrades without losing some files, and I don't even
> think that this happens often. Did you actually see this case in
> practice?
>

I didn't see this happen in practice, and agree that it is a pathological
case.

It might be a good idea though, to not diverge from unstable in regards to
build-tools too much, I guess.

Of course I can also understand the goal to save space on the cds. Hence I
wouldn't mind if you mark the bug as won't fix, and consider it again if real
breakage should happen.

Cheers,
      Stefan.

Martin Pitt (pitti) wrote :

Right. I don't think that we should sacrifice CD space just for this rather academic case, and even if it happens it does not actually break people's machines. In the worst case it can cause some documentation to be missing.

Changed in cdbs:
status: Confirmed → Won't Fix
Fabien Tassin (fta) wrote :

$ ls -l /usr/share/doc/chromium-browser/changelog.Debian.gz
lrwxrwxrwx 1 root root 45 2011-03-02 07:28 /usr/share/doc/chromium-browser/changelog.Debian.gz -> ../chromium-codecs-ffmpeg/changelog.Debian.gz
$ ls -L /usr/share/doc/chromium-browser/changelog.Debian.gz
ls: cannot access /usr/share/doc/chromium-browser/changelog.Debian.gz: No such file or directory

chromium-browser depends on "chromium-codecs-ffmpeg | chromium-codecs-ffmpeg-extra"
and those two conflicts with each other.

i have the latter installed, boom.
As it's Won't fix, I guess I'll set CDBS_NO_DOC_SYMLINKING and do my own symlinking.

wdoekes (walter+ubuntu) wrote :

Right now I have the former installed, also boom.

```
$ dpkg -L chromium-browser | grep changelog.Debian
/usr/share/doc/chromium-browser/changelog.Debian.gz

$ dpkg -l | grep chromium-
ii chromium-browser 72.0.3626.119-0ubuntu0.18.04.1 amd64 Chromium web browser, open-source version of Chrome
ii chromium-codecs-ffmpeg 72.0.3626.119-0ubuntu0.18.04.1 amd64 Free ffmpeg codecs for the Chromium Browser

$ ls -l /usr/share/doc/chromium-browser/changelog.Debian.gz
lrwxrwxrwx 1 root root 51 feb 25 15:56 /usr/share/doc/chromium-browser/changelog.Debian.gz -> ../chromium-codecs-ffmpeg-extra/changelog.Debian.gz

$ ls -l ../chromium-codecs-ffmpeg-extra/changelog.Debian.gz
ls: cannot access '../chromium-codecs-ffmpeg-extra/changelog.Debian.gz': No such file or directory
```

I don't think saving 2k warrants breaking sane access to the changelog:
```
$ ls -l /usr/share/doc/chromium-browser/
total 1108
lrwxrwxrwx 1 root root 51 feb 25 15:56 changelog.Debian.gz -> ../chromium-codecs-ffmpeg-extra/changelog.Debian.gz
-rw-r--r-- 1 root root 1126239 okt 25 2017 copyright
-rw-r--r-- 1 root root 2512 okt 25 2017 copyright.problems.gz
-rw-r--r-- 1 root root 2975 okt 25 2017 README.source

$ ls -l /usr/share/doc/chromium-codecs-ffmpeg/
total 1104
-rw-r--r-- 1 root root 2263 feb 25 15:56 changelog.Debian.gz
-rw-r--r-- 1 root root 1126239 okt 25 2017 copyright
```

That copyright file takes up actual space but is not symlinked, :thinking_face:
```
$ md5sum /usr/share/doc/chromium-{browser,codecs-ffmpeg}/copyright
983091d3a4c4e207f2146a911a7f7387 /usr/share/doc/chromium-browser/copyright
983091d3a4c4e207f2146a911a7f7387 /usr/share/doc/chromium-codecs-ffmpeg/copyright
```

wdoekes (walter+ubuntu) wrote :

(Not sure whose responsibility this is. I did not find the problematic packaging code directly. Also filed as #1818987 under chromium-browser.)

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers